Java中try catch finally语句中含return语句的执行情况总结-编程陷阱

原创 2015年12月08日 16:11:34

前言:有java编程基础的人对java的异常处理机制都会有一定了解,而且可能感觉使用起来也比较简单,但如果在try catch finally语句块中遇到return语句,开发者可能就会遇到一些逻辑问题,甚至步入编程的陷阱。不信,我们先看看一段小程序,读者可以分析其逻辑然后猜测其输出结果:

public class Test {
    public static void main(String[] args) {
        Test t = new Test();
        System.out.println(t.Test1());
    }

    public boolean Test1() {
        boolean b = true;
        try {
            int i = 10 / 0; 
            System.out.println("i = " + i);
            return true; 
        } catch (Exception e) {
            System.out.println(" -- catch --");
            System.out.println("b:" + b);
            return b = false; 
        } finally {
            System.out.println(" -- finally --");
            System.out.println("b:" + b);
        }
    }
}

请先停止继续阅读,试着说出其运行结果。
如果你不能很自信地正确说出这段程序的执行逻辑和结果,那本文就值得你一读,如果你可以,请忽略本文。
执行结果是:
– catch –
b:true
– finally –
b:false
false
你说对了吗?

正文
首先我们了解java的异常处理机制中try、catch、finally的基本执行逻辑。

  • try:包裹可能引发异常的代码
  • catch:可以有多个catch块,一个代码块对应一种异常类型,表明该catch块用于处理此类型的异常。
  • finally:主要用于回收在try块里使用的物理资源(比如数据库连接、网络连接和磁盘文件等),这些物理资源必须显示回收,因为java的垃圾回收机制不会回收任何的物理资源,垃圾回收机制只回收堆内存中对象所占用的内存。异常机制保证finally块内的代码总是被执行,除非在try块或者catch块中调用了退出虚拟机的方法(即System.exit(1);),此时程序直接退出,不再执行finally块。

首先明确其语法结构:
1. try块必存在, catch块和finally块都是可选的,但两者需至少出现其中之一,也可以同时出现;
2. 可以有多个catch块,捕获父类异常的catch块必须位于捕获子类异常的后面,即设计多个catch块捕获异常时要先捕获小的异常,再捕获大的异常。一般,try块后只有一个catch块会被执行,绝不可能有多个catch块被执行,除非使用continue开始下次循环时,再次执行到这个try、catch块,而捕获处理其他catch的异常;
3. 多个catch块必须位于try块之后,finally块必须位于所有catch块之后。

下面我们分情况讨论try、catch、finally中含有return的情况。
示例一(try、catch、finally中都有return):

public class Test {
    public static void main(String[] args) {
        Test t = new Test();
        System.out.println(t.Test1());
    }

    public boolean Test1() {
        try {
            int i = 10 / 0; // 抛出 Exception,try中其他代码不执行,进入catch
            System.out.println("i = " + i);
            return true; 
        } catch (Exception e) {
            System.out.println(" -- catch --");
            return false;
        } finally {
            System.out.println(" -- finally --");
            return true;
        }
    }
}

Eclipse中,这段代码会出警告:finally block does not complete normally。译为:finally块不能正常完成。Java不建议在finally块中使用renturn或throw等导致方法终止的语句,否则将会导致try块、catch块中的return、throw语句失效。但是仍然可以执行,结果为:
– catch –
– finally –
true
这里最后打印的true即时finally中返回的true。至于为什么会覆盖,这个涉及到JVM底层字节码的具体实现和一些指令操作,具体可以参考这里:JVM中finally子句介绍 如果没有JVM和计算机组成原理以及操作系统的相关基础知识是较难以理解的,有余力的开发者可以深入研究。

实例二(try、catch中有return,finally中无):

public class Test {
    public static void main(String[] args) {
        Test t = new Test();
        System.out.println(t.Test1());
    }

    public boolean Test1() {
        try {
            int i = 10 / 0; // 抛出 Exception,try中其他代码不执行,进入catch
            System.out.println("i = " + i);
            return true; // 不会执行
        } catch (Exception e) {
            System.out.println(" -- catch --");
            return false; // Exception 抛出,获得了返回false的机会
        } finally {
            System.out.println(" -- finally --");
        }
    }
}

执行结果:
– catch –
– finally –
false

断点调试可发现其逻辑:在finally执行后,又回到catch语句里面的return上,然后返回这句中的false。然后,很多人就会认为,甚至很多技术博客都写到:只有finally块执行完成之后,才会回来执行try或者catch块中的return语句。 但是!!真的是这样吗?也许是说这话的人知道意思但表达不够清楚,以至于让笔者觉得是误人子弟,try、catch中的rerun语句的逻辑是否执行?执行完finally块后一定会返回去执行try、catch吗?我们回过头来看开篇的那段代码:

public class Test {
    public static void main(String[] args) {
        Test t = new Test();
        System.out.println(t.Test1());
    }
    public boolean Test1() {
        boolean b = true;
        try {
            int i = 10 / 0; 
            System.out.println("i = " + i);
            return true; 
        } catch (Exception e) {
            System.out.println(" -- catch --");
            System.out.println("b:" + b);
            return b = false; 
        } finally {
            System.out.println(" -- finally --");
            System.out.println("b:" + b);
        }
    }
}

代码中我们将catch中的return语句加上了一个赋值操作,断点调试,可以发现,程序执行到int i = 10 / 0; 语句后跳出catch块,并完整执行到return b = false; 然后进入finally块,执行两条输出语句,第二条System.out.println(“b:” + b);这里的b变成了false!,说明之前return中的赋值语句有执行,执行完finally后,程序再次进入catch中的return,返回给调用者。所以事实是,当Java程序执行try块、catch块遇到return语句时,当系统执行完return语句之后,并不会立即结束该方法,而是去寻找该异常处理流程中是否包含finally块,如果没有finally块,方法终止,返回相应的返回值。如果有finally块,系统立即开始执行finally块——只有当finally块执行完成后,系统才会再次跳回来根据return语句结束方法。如果finally块里使用了return语句来导致方法结束,则finally块已经结束了方法,系统不会跳回去执行try、catch块里的任何代码。

依照此标准,下列程序应该输出什么?

public class Test {
    public static void main(String[] args) {
        Test t = new Test();
        System.out.println(t.test());
    }

    public static int test() {
        int count = 5;
        try {
            return ++count;
        } catch (Exception e) {
            // TODO: handle exception
        } finally {
            System.out.println("finally()执行");
            return count++;
        }
    }
}

答案是:
finally()执行
6

下面还有一个较难的判断程序:

public class Test {
    public static void main(String[] args) {
        int a  = test();
        System.out.println(a);
    }

    public static int test() {
        int count = 5;
        try {
            throw new RuntimeException("测试异常");
        } catch (Exception e) {
            // TODO: handle exception
        } finally {
            System.out.println("finally()执行");
            return count;
        }
    }
}

运行结果:
finally()执行
5

一般读者可能以为上面程序会抛出异常,test()方法非正常终止,test()方法应该没有返回值。但事实上,test()方法完全可以正常结束,而test()方法返回了5,看起来throw语句完全失去了作用。
不过,依然按照标准分析,系统执行throw语句时并不会立即抛出异常,而是去寻找该异常处理流中是否包含finally块。如果没有finally块,程序立即抛出异常;如果有finally块,系统立即开始执行finally块——只有当finally块执行完成后,系统才会再次跳回来抛出异常。如果finally块里使用return语句来结束方法,系统将不会跳回去执行try块、catch块去抛出异常。

实践是检验真理的唯一标准。学会用质疑的眼光求真,用踏实的态度去实践,是每一个成熟的技术人员所必须的。

请尊重原创,转载请注明出处:
http://blog.csdn.net/daijin888888/article/details/48369809

版权声明:本文为博主原创文章,未经博主允许不得转载。博主地址:http://blog.csdn.net/daijin888888

相关文章推荐

java捕获到异常以后,后面的代码还会执行吗?

转自:http://zhidao.baidu.com/link?url=BgAg2K6tQumyPRJyjIWCGEQe-knlVG-N67MUp1QoZyvkzvb7qZ3QpLz101rtAOqk...

Java异常之catch语句块

今天在阅读项目代码时看到如下奇怪的代码,以为是竖线 | 可以作为多类型赋值,经过网上搜索才知道是Java SE 7新增的功能:一个catch捕获多种类型的异常。原文是Java官方的文档,现翻译如下。红...

java设计模式之简单工厂模式

软件开发中学好设计模式可以让你不用重复去造轮子。那么什么是设计模式呢? 设计模式:是一种解决特定环境下、重复出现的、特定问题的解决方案。 在开发软件的过程中,可能会碰到许多特定的问题,利用设计模式...
  • H_Zhang
  • H_Zhang
  • 2016年04月20日 20:18
  • 952

三大UML建模工具Visio、Rational Rose、PowerDesign的区别

UML建模工具相信大家有所了解,那么你对UML建模工具Visio 、Rational Rose、PowerDesign之间的区别和联系是否了解,这里就像大家简单介绍一下。   UML建模工具V...

Java中try catch finally语句中含有return语句的执行情况(总结版)

在这里看到了try catch finally块中含有return语句时程序执行的几种情况,但其实总结的并不全,而且分析的比较含糊。但有一点是可以肯定的,finally块中的内容会先于try中的ret...

(转)java 中的try catch finally 语句中含有return语句的执行情况(总结版)

原处:http://blog.csdn.net/ns_code/article/details/17485221   在这里看到了try catch finally块中含有return语句时程序执行的...

Java中try catch finally语句中含有return语句的执行情况(总结版)

转载请注明出处:http://blog.csdn.net/ns_code/article/details/17485221     在这里看到了try catch finally块中...

Java中try catch finally语句中含有return语句的执行情况(总结版)

在这里看到了try catch finally块中含有return语句时程序执行的几种情况,但其实总结的并不全,而且分析的比较含糊。但有一点是可以肯定的,finally块中的内容会先于try中的ret...

Java中try catch finally语句中含有return语句的执行情况(总结版)

在这里看到了try >但有一点是可以肯定的,finally块中的内容会先于try中的return语句执行,如果finall语句块中也有return语句的话,那么直接从finally中返回了,这也是不建...

try catch finally中有return语句的执行情况及原因分析

前言之前在学习Java异常时遇到了try cathc finally中有return的情况,但是到底return执不执行,以怎样的顺序执行,以及原因是什么,还没弄清楚。 1 执行顺序以及原因先来看一...
内容举报
返回顶部
收藏助手
不良信息举报
您举报文章:Java中try catch finally语句中含return语句的执行情况总结-编程陷阱
举报原因:
原因补充:

(最多只允许输入30个字)